﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace Grouping
{
    public class Contacts : INotifyPropertyChanged
    {

        #region Fields

        private string contactName;
        private string contactNumber;
        private string designation;
        private string color;
        private ImageSource image;
        private bool isVisible = false;
        private string expandOrCollapse = "+";

        #endregion

        #region Property
        public string ExpandOrCollapse
        {
            get { return expandOrCollapse; }
            set
            {
                expandOrCollapse = value;
                this.RaisedOnPropertyChanged("ExpandOrCollapse");
            }
        }

        public string ContactName
        {
            get { return contactName; }
            set
            {
                if (contactName != value)
                {
                    contactName = value;
                    this.RaisedOnPropertyChanged("ContactName");
                }
            }
        }

        public string Designation
        {
            get { return designation; }
            set
            {
                if (designation != value)
                {
                    designation = value;
                    this.RaisedOnPropertyChanged("Designation");
                }
            }
        }
        public string Color
        {
            get { return color; }
            set
            {
                color = value;
                this.RaisedOnPropertyChanged("Color");
            }

        }
        public bool IsVisible
        {
            get { return isVisible; }
            set
            {
                isVisible = value;
                this.RaisedOnPropertyChanged("IsVisible");
            }
        }

        public string ContactNumber
        {
            get { return contactNumber; }
            set
            {
                if (contactNumber != value)
                {
                    contactNumber = value;
                    this.RaisedOnPropertyChanged("ContactNumber");
                }
            }
        }

        public ImageSource ContactImage
        {
            get { return this.image; }
            set
            {
                this.image = value;
                this.RaisedOnPropertyChanged("ContactImage");
            }
        }

        #endregion

        #region Constractor

        public Contacts()
        {

        }

        public Contacts(string name, string number)
        {
            contactName = name;
            contactNumber = number;
        }

        #endregion

        #region INotifyPropertyChanged

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisedOnPropertyChanged(string _PropertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(_PropertyName));
            }
        }

        #endregion
    }
}
